#!/usr/bin/python
import xml.etree.ElementTree as ET
import sys
import fpdf
from xml.dom import XML_NAMESPACE, minidom
from tabulate import tabulate

def parseXML(xml_file):
	# Carregar l'arxiu XML
	tree = ET.parse(xml_file)
	root = tree.getroot()
	# Utilitzar el namespace (espai de noms) XML
	namespace = {"qlc": "http://www.qlcplus.org/Workspace"}
	cap=['Fabricant', 'Model', 'ID Fixture', 'Nom', 'Universe', 'Adreça Ini', 'Adreça Fi', 'Canals']
	fixtures=[]
	for fixture in root.findall(".//qlc:Fixture", namespace):
		manufacturer = fixture.find("qlc:Manufacturer", namespace).text
		model = fixture.find("qlc:Model", namespace).text
		fixture_id = fixture.find("qlc:ID", namespace).text
		fixture_name = fixture.find("qlc:Name", namespace).text
		universe = fixture.find("qlc:Universe", namespace).text
		address = int(fixture.find("qlc:Address", namespace).text)+1
		channels = fixture.find("qlc:Channels", namespace).text
		addressend = int(fixture.find("qlc:Address", namespace).text)+int(fixture.find("qlc:Channels", namespace).text)
		dades=[manufacturer, model , fixture_id, fixture_name, universe, address, addressend, channels]
		fixtures.append(dades)
	fixtures.sort(key=lambda fixtures: fixtures[5])
	fixtures.insert(0, cap)
	f = open(xml_file+'.txt', 'w')
	print("\nProjecte: ", xml_file, file=f)
	print("\nCanals Fixtures", file=f)
	print(tabulate(fixtures), file=f)
	
def main():
	if len(sys.argv) >= 2:
		# ~ print(sys.argv)
		filename = sys.argv[1]
		parseXML(filename)
	else:
		print ("Please specify a patch file to read")

if __name__ == "__main__":
	main()
